#ifndef INTERRUPT_H
#define INTERRUPT_H
/////////////////////////////////////////////////////////////////////////////
//
// File: interrupt.h
// -----------------
// The interrupt priority decoder with up to 32 interrupts (0-31).
// Call setInterrupt(_) with a number to add a new interrupt request
// Call 

#include <iostream>

class IRQDecoder {
	public:
		// default constructor
		IRQDecoder();
		
		// call request to request an interrupt of type no
		void request( int );
		
		// call start(_) when you start handling interrupt number "no"
		void start( int );
		
		// call done() when done handling the current interrupt (automatically 
		// clears the most important serviced interrupt)
		void done();
		
		// call find() to find the next interrupt to service. If you choose to 
		// service that interrupt, call start(_). If no new interrupt is found,
		// -1 is returned, meaning that no higher-priority interrupts are waiting
		// to be serviced.
		int find();
		
		// write the state of the interruptcontroller to the stream
		void state(ostream&);
		
		// query whether a request for the interrupt is given
		bool isReq( int );
		
	protected:
		// the interrupts requesting service
		bool irq[32];

		// the interrupt numbers currently being serviced
		bool servicing[32];
		
};		


#endif