/////////////////////////////////////////////////////////////////////////////
//
// File: timer.cpp
// ---------------
//
#include "timer.h"

// initialize the timer
Timer::Timer(IRQDecoder* i, BYTE n): 
	eventval(0), 
	count(0), 
	irq(i),
	irqno(n)  { 
	control.word=0; 
}

// perform a single tick on this timer
void Timer::clk() { 
	if (control.flags.enabled) {
		if (count++==eventval) {
			control.flags.event = 1;
			if (control.flags.reset) {
				count = 0;
			}
		}
	}
	if (control.flags.event && irq) irq->request(irqno);
}

// set the event count (the count where an interrupt may be generated)				
void Timer::setEvent( WORD ev ) { 
	eventval = ev;
}

// set the control-word
void Timer::setControl( WORD ctrl ) { 
	control.word = ctrl; 
}

// return the current count (read off data)
WORD Timer::getCount() { 
	return count; 
}

// return the control-word
WORD Timer::getControl() { 
	return control.word; 
}

// return true if an event is pending in the timer
bool Timer::getEvent() {
	return control.flags.event;
}